#ifdef Use_FSM
/* Statistical labeller: FSMs.

   04-01-93 Created
   26-04-93 Interface changed
   16 Jan 2004 Cleaned up for open source release.
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   For details, see the file LICENCE, or visit http://www.gnu.org/copyleft/gpl.html
    
   Copyright (C) David Elworthy 2004.
*/

/* Read the FSM definitions */
extern void fsm_read(FILE *in);
extern void fsm_read_named(char *name);

/* Advance FSMs on input; call on setting up a new node */
extern void fsm_advance(Node node, Trans *trans, Trans *new);

/* Dump a fsm state for chart/debugging */
extern void fsm_dump_state(FILE *out, int depth, FSMState state);

/* Initialise a fsm state; call on creating a node */
extern void fsm_init_node(Node node);

/* Free a fsm state; call on freeing a node */
extern void fsm_free_node(Node node);

/* Tell labeller if tagging is allowed */
extern BOOL fsm_may_tag(Lexeme top);
#endif
