#ifdef Use_Parser
/* Statistical labeller: Parser.

   31-03-93 Created
   22-04-93 Integrate chart with main data structures
   16 Jan 2004 Cleaned up for open source release.
    
   Copyright (C) David Elworthy 2004.
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   For details, see the file LICENCE, or visit http://www.gnu.org/copyleft/gpl.html

   See the documentation for a specification of the syntax and semantics.
*/

/* Read parser rules */
extern void parser_read(FILE *in);
extern void parser_read_named(char *name);

/* Advance the parser; call when a new node has been set up. This may create
   phrases, which are then tagged if "trans" is non-NULL. "new" is needed only
   if re-estimation is being used. */
extern void parser_advance(Node node, Trans *trans, Trans *new);

/* Dump an active edge; called during chart/debugging output */
extern void parser_dump_edge(FILE *out, Hyp hyp);

/* Initialise an active hyp; called when a hypothesis created */
extern void parser_init_hyp(Hyp hyp);

/* Free an active hyp; called when a hypothesis is being freed */
extern void parser_free_hyp(Hyp hyp);

/* Tell labeller if tagging is allowed */
extern BOOL parser_may_tag(Lexeme top);
#endif
