/* Statistical labeller: common pharsal functions

   21-05-93 Created from other soruce files
   16 Jan 2004 Cleaned up for open source release.
    
   Copyright (C) David Elworthy 2004.
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   For details, see the file LICENCE, or visit http://www.gnu.org/copyleft/gpl.html
*/


/* Type for a list of tags */
typedef struct tags_st TagsSt, *Tags;
struct tags_st
{
    Tags next;
    Tag  tag;
};

/* Add a tag to a sorted tags list */
extern Tags add_tag_to_list(Tags head, Tag tag);

/* Free a tags list */
extern void free_tags_list(Tags tags);

/* Match a Tags list and a score hyp list into an unscored hyp list */
extern Link match_tags_list(Tags tags, Link hyps, BOOL lex_only);

/* Dump out details of a phrase */
extern void dump_phrase_hyp(FILE *out, Hyp hyp);

/* Construct a node during phrase construction */
extern Node build_subsumed_node(Node succ, Hyp hyp);

/* Make a node with a list of hyps */
extern Node make_node(Node succ, Link hyps, Node start, Node end);

/* Call tagger on a phrasal hypothesis */
extern void tag_phrase(Hyp h, Trans *trans, Trans *new);
